cover = document.querySelector(".couverture");
firstPage = document.createElement("div");
firstPage.classList.add("page");
firstPage.classList.add("firstPage");
firstPage.classList.add("couverture");

firstPage.innerHTML = cover.innerHTML;

document.body.insertBefore(firstPage, document.querySelector(".couvertures").nextElementSibling)

var sections = document.querySelectorAll(".recette");
var i = 0;

for (const section of sections) {

    var div = section.querySelector(".sketchwrapper");
    div.id = "s" + i;
    var codeDiv = section.querySelector("code");

    if (codeDiv.innerText.length > 0) {
        var code = codeDiv.innerText;
        code = wrapCode(code, i);
        eval(code);
    } else {
        getCode(codeDiv, i);
    }

    var texte = section.querySelector(".texte");
    var buttonCode = document.createElement("button");
    buttonCode.textContent = "{}/abc"
    // section.querySelector(".programme").insertBefore(buttonCode, texte);
    section.querySelector(".programme").firstElementChild.appendChild(buttonCode);

    buttonCode.addEventListener("click", (e) => {
        console.log("e")
        if (e.currentTarget.parentNode.parentNode.classList.contains("code")) {
            e.currentTarget.parentNode.parentNode.classList.remove("code");
        } else {
            e.currentTarget.parentNode.parentNode.classList.add("code")
        }
    })
    i++;
}
async function getCode(codeDiv, i) {
    script_path = codeDiv.dataset.sketch;
    const response = await fetch(script_path);
    const text = await response.text();
    codeDiv.innerText = text;

    jsCodeColor(codeDiv);

    console.log(codeDiv.dataset.autoconvert)
    if (typeof codeDiv.dataset.p5convert !== 'undefined') {
        code = wrapCode(text, i);
    } else {
        code = text;
    }
    eval(code);
}

function wrapCode(code, i) {
    console.log(code);
    code = "let PLAYPAUSE = true;\n" + code;
    console.log("wrap")
    code = code.replace(/function( *)setup( *)\((.*)\)( *){/g, 'function setup(){let button = createButton("▶ ⏸︎");button.position(0, 0);button.mousePressed(p.playpause);')
    // Structure
    code = code.replaceAll(/\bfunction( +)(draw|setup|preload|keyPressed|keyReleased|keyTyped|mouseMoved|mouseDragged|mousePressed|mouseReleased|mouseClicked|doubleClicked|mouseWheel|touchStarted|touchMoved|touchEnded)( *)\((.*)/g, 'p.$2 = function($4');
    code = code.replaceAll(/\b(?<!\.)(remove|noLoop|loop|isLooping|push|pop|redraw)\b( *)\(/g, 'p.$1(');
    // Environment
    code = code.replaceAll(/\b(?<!\.)(width|height|webglVersion|displayWidth|displayHeight|windowWidth|windowHeight|frameCount|deltaTime|focused)\b/g, 'p.$1');
    code = code.replaceAll(/\b(?<!\.)(describe|describeElement|textOutput|gridOutput|print|cursor|frameRate|getTargetFrameRate|noCursor|windowResized|fullscreen|pixelDensity|displayDensity|getURL|getURLPath|getURLParam)\b( *)\(/g, 'p.$1(');
    // Color
    code = code.replaceAll(/\b(?<!\.)(alpha|brightness|color|green|hue|lerpColor|lightness|TEXT|saturation|beginClip|endClip|clip|background|clear|colorMode|fill|noFill|noStroke|stroke|erase|noErase)\b( *)\(/g, 'p.$1(');
    // Shape
    code = code.replaceAll(/\b(?<!\.)(arc|ellipse|circle|line|point|quad|rect|square|triangle|ellipseMode|noSmooth|rectMode|smooth|strokeCap|strokeJoin|strokeWeight|bezier|bezierDetail|bezierPoint|bezierTangent|curve|curveDetail|curveTightness|curvePoint|curveTangent|beginContour|beginShape|bezierVertex|curveVertex|endContour|endShape|quadraticVertex|vertex|normal|beginGeometry|endGeometry|buildGeometry|freeGeometry|plane|box|sphere|cylinder|cone|ellipsoid|torus|loadModel|model)\b( *)\(/g, 'p.$1(');
    // Constantes
    code = code.replaceAll(/\b(?<!\.)(HALF_PI|PI|QUARTER_PI|TAU|TWO_PI|DEGREES|RADIANS|PD2|WEBGL|WEBGL2|ARROW|CROSS|HAND|MOVE|TEXT|WAIT|DEG_TO_RAD|RAD_TO_DEG|CORNER|CORNERS|RADIUS|RIGHT|LEFT|CENTER|TOP|BOTTOM|BASELINE|POINTS|LINES|LINE_STRIP|LINE_LOOP|TRIANGLES|TRIANGLE_FAN|TRIANGLE_STRIP|QUADS|QUAD_STRIP|TESS|CLOSE|OPEN|CHORD|PIE|PROJECT|SQUARE|ROUND|BEVEL|MITER|RGB|HSL|BSB|AUTO|ALT|BACKSPACE|CONTROL|DELETE|DOWN_ARROW|ENTER|ESCAPE|LEFT_ARROW|OPTION|RETURN|RIGHT_ARROW|SHIFT|TAB|UP_ARROW|BLEND|REMOVE|ADD|DARKEST|LIGHTEST|DIFFERENCE|SUBSTRACT|EXCLUSION|MULTIPLY|SCREEN|REPLACE|OVERLAY|HARD_LIGHT|SOFT_LIGHT|DODGE|BURN|THRESHOLD|GRAY|OPAQUE|INVERT|POSTERIZE|DILATE|ERODE|BLUR|NORMAL|ITALIC|BOLD|BOLDITALIC|CHAR|WORD|LINEAR|QUADRATIC|BEZIER|CURVE|STROKE|FILL|TEXTURE|IMMEDIATE|IMAGE|NEAREST|REPEAT|CLAMP|MIRROR|FLAT|SMOOTH|LANDSCAPE|PORTRAIT|GRID|AXES|LABEL|FALLBACK|CONTAIN|COVER|FLOAT|HALF_FLOAT|UNSIGNED_BYTE|UNSIGNED_INT|RGBA)\b/g, 'p.$1');
    // Text & font
    code = code.replaceAll(/\b(?<!\.)(textAlign|textLeading|textSize|textStyle|textWidth|textAscent|textDescent|textWrap|loadFont|text|textFont)\b( *)\(/g, 'p.$1(');
    // DOM
    code = code.replaceAll(/\b(?<!\.)(select|selectAll|removeElements|changed|input|createDiv|createP|createSpan|createImg|createA|createSlider|createButton|createCheckbox|createSelect|createRadio|createColorPicker|createInput|createFileInput|createVideo|createAudio|createCapture|createElement)\b( *)\(/g, 'p.$1(');
    // Rendering
    code = code.replaceAll(/\b(?<!\.)(createCanvas|resizeCanvas|noCanvas|createGraphics|createFramebuffer|clearDepth|blendMode|drawingContext|setAttributes)\b( *)\(/g, 'p.$1(');
    // Transform
    code = code.replaceAll(/\b(?<!\.)(applyMatrix|resetMatrix|rotate|rotateX|rotateY|rotateZ|scale|shearX|shearY|translate)\b( *)\(/g, 'p.$1(');
    // Data 
    code = code.replaceAll(/\b(?<!\.)(storeItem|getItem|clearStorage|removeItem|createStringDict|createNumberDict|append|arrayCopy|concat|reverse|shorten|shuffle|sort|splice|subset|float|int|str|boolean|byte|char|unchar|hex|unhex|join|match|matchAll|nf|nfc|nfp|nfs|split|splitTokens|trim)\b( *)\(/g, 'p.$1(');
    // Math
    code = code.replaceAll(/\b(?<!\.)(abs|ceil|constrain|dist|exp|floor|lerp|log|mag|map|max|min|norm|pow|round|sq|sqrt|fract|createVector|noise|noiseDetail|noiseSeed|randomSeed|random|randomGaussian|acos|asin|atan|atan2|cos|sin|tan|degrees|radians|angleMode)\b( *)\(/g, 'p.$1(');
    // Events
    code = code.replaceAll(/\b(?<!\.)(setMoveThreshold|setShakeThreshold|deviceMoved|deviceTurned|deviceShaken|keyIsDown|requestPointerLock|exitPointerLock)\b( *)\(/g, 'p.$1(');
    code = code.replaceAll(/\b(?<!\.)(deviceOrientation|accelerationX|accelerationY|accelerationZ|pAccelerationX|pAccelerationY|pAccelerationZ|rotationX|rotationY|rotationZ|pRotationX|pRotationY|pRotationZ|turnAxis|keyIsPressed|key|keyCode|movedX|movedY|mouseX|mouseY|pmouseX|pmouseY|winMouseX|winMouseY|pwinMouseX|pwinMouseY|mouseButton|mouseIsPressed|touches)\b/g, 'p.$1');
    // Image
    code = code.replaceAll(/\b(?<!\.)(createImage|saveCanvas|saveFrames|loadImage|saveGif|image|tint|noTint|imageMode|blend|copy|filter|get|loadPixels|set|updatePixels)\b( *)\(/g, 'p.$1(');
    code = code.replaceAll(/\b(?<!\.)(pixels)\b/g, 'p.$1');
    // IO
    code = code.replaceAll(/\b(?<!\.)(loadJSON|loadStrings|loadTable|loadXML|loadBytes|httpGet|httpPost|httpDo|createWriter|save|saveJSON|saveStrings|saveTable|day|hour|minute|millis|month|second|year)\b( *)\(/g, 'p.$1(');
    // 3D
    code = code.replaceAll(/\b(?<!\.)(orbitControl|debugMode|noDebugMode|ambientLight|specularColor|directionalLight|pointLight|imageLight|panorama|lights|lightFalloff|spotLight|noLights|loadShader|createShader|createFilterShader|shader|resetShader|texture|textureMode|textureWrap|normalMaterial|ambientMaterial|emissiveMaterial|specularMaterial|shininess|metalness)\b( *)\(/g, 'p.$1(');
    code = code.replaceAll(/\b(?<!\.)(camera|createCamera|frustum|linePerspective|ortho|perspective|setCamera)\b( *)\(/g, 'p.$1(');

    // add functions linked to play/stop button
    code = code + "\np.playpause = function() {if(PLAYPAUSE){p.noLoop();}\nelse{p.loop();}\nPLAYPAUSE = !PLAYPAUSE;}"

    code = "s" + i + " = ( p ) => {" + code + "}; " + "new p5(s" + i + ",'s" + i + "');";
    console.log(code);
    return code;
}

function jsCodeColor(elmnt) {
    // from w3CodeColor
    var elmntObj = (document.getElementById(elmnt) || elmnt);
    var elmntTxt = elmntObj.innerHTML;

    var commentcolor = "grey"
    var jscolor = "black";
    var jskeywordcolor = "mediumblue";
    var jsstringcolor = "purple";
    var jsnumbercolor = "red";
    var jspropertycolor = "black";
    //   elmntObj.style.fontFamily = "Consolas,'Courier New', monospace";

    elmntTxt = jsMode(elmntTxt);

    elmntObj.innerHTML = elmntTxt;

    function extract(str, start, end, func, repl) {
        var s, e, d = "",
            a = [];
        while (str.search(start) > -1) {
            s = str.search(start);
            e = str.indexOf(end, s);
            if (e == -1) {
                e = str.length;
            }
            if (repl) {
                a.push(func(str.substring(s, e + (end.length))));
                str = str.substring(0, s) + repl + str.substr(e + (end.length));
            } else {
                d += str.substring(0, s);
                d += func(str.substring(s, e + (end.length)));
                str = str.substr(e + (end.length));
            }
        }
        this.rest = d + str;
        this.arr = a;
    }

    function jsMode(txt) {
        var rest = txt,
            done = "",
            esc = [],
            i, cc, tt = "",
            sfnuttpos, dfnuttpos, compos, comlinepos, keywordpos, numpos, mypos, dotpos, y;
        for (i = 0; i < rest.length; i++) {
            cc = rest.substr(i, 1);
            if (cc == "\\") {
                esc.push(rest.substr(i, 2));
                cc = "W3JSESCAPE";
                i++;
            }
            tt += cc;
        }
        rest = tt;
        y = 1;
        while (y == 1) {
            sfnuttpos = getPos(rest, "'", "'", jsStringMode);
            dfnuttpos = getPos(rest, '"', '"', jsStringMode);
            compos = getPos(rest, /\/\*/, "*/", commentMode);
            comlinepos = getPos(rest, /\/\//, "<br>", commentMode);
            numpos = getNumPos(rest, jsNumberMode);
            keywordpos = getKeywordPos("js", rest, jsKeywordMode);
            dotpos = getDotPos(rest, jsPropertyMode);
            if (Math.max(numpos[0], sfnuttpos[0], dfnuttpos[0], compos[0], comlinepos[0], keywordpos[0], dotpos[0]) == -1) {
                break;
            }
            mypos = getMinPos(numpos, sfnuttpos, dfnuttpos, compos, comlinepos, keywordpos, dotpos);
            if (mypos[0] == -1) {
                break;
            }
            if (mypos[0] > -1) {
                done += rest.substring(0, mypos[0]);
                done += mypos[2](rest.substring(mypos[0], mypos[1]));
                rest = rest.substr(mypos[1]);
            }
        }
        rest = done + rest;
        for (i = 0; i < esc.length; i++) {
            rest = rest.replace("W3JSESCAPE", esc[i]);
        }
        return "<span style=color:" + jscolor + ">" + rest + "</span>";
    }

    function commentMode(txt) {
        return "<span class='code_comment' style=color:" + commentcolor + ">" + txt + "</span>";
    }

    function jsStringMode(txt) {
        return "<span style=color:" + jsstringcolor + ">" + txt + "</span>";
    }

    function jsKeywordMode(txt) {
        return "<span style=color:" + jskeywordcolor + ">" + txt + "</span>";
    }

    function jsNumberMode(txt) {
        return "<span style=color:" + jsnumbercolor + ">" + txt + "</span>";
    }

    function jsPropertyMode(txt) {
        return "<span style=color:" + jspropertycolor + ">" + txt + "</span>";
    }

    function getDotPos(txt, func) {
        var x, i, j, s, e, arr = [".", "<", " ", ";", "(", "+", ")", "[", "]", ",", "&", ":", "{", "}", "/", "-", "*", "|", "%"];
        s = txt.indexOf(".");
        if (s > -1) {
            x = txt.substr(s + 1);
            for (j = 0; j < x.length; j++) {
                cc = x[j];
                for (i = 0; i < arr.length; i++) {
                    if (cc.indexOf(arr[i]) > -1) {
                        e = j;
                        return [s + 1, e + s + 1, func];
                    }
                }
            }
        }
        return [-1, -1, func];
    }

    function getMinPos() {
        var i, arr = [];
        for (i = 0; i < arguments.length; i++) {
            if (arguments[i][0] > -1) {
                if (arr.length == 0 || arguments[i][0] < arr[0]) {
                    arr = arguments[i];
                }
            }
        }
        if (arr.length == 0) {
            arr = arguments[i];
        }
        return arr;
    }

    function getKeywordPos(typ, txt, func) {
        var words, i, pos, rpos = -1,
            rpos2 = -1,
            patt;
        if (typ == "js") {
            words = ["abstract", "arguments", "boolean", "break", "byte", "case", "catch", "char", "class", "const", "continue", "debugger", "default", "delete",
                "do", "double", "else", "enum", "eval", "export", "extends", "false", "final", "finally", "float", "for", "function", "goto", "if", "implements", "import",
                "in", "instanceof", "int", "interface", "let", "long", "NaN", "native", "new", "null", "package", "private", "protected", "public", "return", "short", "static",
                "super", "switch", "synchronized", "this", "throw", "throws", "transient", "true", "try", "typeof", "var", "void", "volatile", "while", "with", "yield"
            ];
        }
        for (i = 0; i < words.length; i++) {
            pos = txt.indexOf(words[i]);
            if (pos > -1) {
                patt = /\W/g;
                if (txt.substr(pos + words[i].length, 1).match(patt) && txt.substr(pos - 1, 1).match(patt)) {
                    if (pos > -1 && (rpos == -1 || pos < rpos)) {
                        rpos = pos;
                        rpos2 = rpos + words[i].length;
                    }
                }
            }
        }
        return [rpos, rpos2, func];
    }

    function getPos(txt, start, end, func) {
        var s, e;
        s = txt.search(start);
        e = txt.indexOf(end, s + (end.length));
        if (e == -1) {
            e = txt.length;
        }
        return [s, e + (end.length), func];
    }

    function getNumPos(txt, func) {
        var arr = ["<br>", " ", ";", "(", "+", ")", "[", "]", ",", "&", ":", "{", "}", "/", "-", "*", "|", "%", "="],
            i, j, c, startpos = 0,
            endpos, word;
        for (i = 0; i < txt.length; i++) {
            for (j = 0; j < arr.length; j++) {
                c = txt.substr(i, arr[j].length);
                if (c == arr[j]) {
                    if (c == "-" && (txt.substr(i - 1, 1) == "e" || txt.substr(i - 1, 1) == "E")) {
                        continue;
                    }
                    endpos = i;
                    if (startpos < endpos) {
                        word = txt.substring(startpos, endpos);
                        if (!isNaN(word)) {
                            return [startpos, endpos, func];
                        }
                    }
                    i += arr[j].length;
                    startpos = i;
                    i -= 1;
                    break;
                }
            }
        }
        return [-1, -1, func];
    }
}